<template>
  <div ref="chart" class="chart"></div>
</template>

<script>
import chartist from 'chartist'

const defaultChartOptions = {
  showArea: true,
  fullWidth: true
}

export default {
  name: 'chart',

  props: {
    data: {
      type: Object,
      validator (value) {
        return value.hasOwnProperty('labels') && value.hasOwnProperty('series')
      }
    },

    title: {
      type: String,
      default: ''
    },

    type: {
      type: String,
      default: 'line',
      validator (value) {
        return ['line', 'bar', 'pie'].includes(value)
      }
    },

    options: {
      type: Object,
      default () {
        return defaultChartOptions
      }
    }
  },

  data () {
    return {
      $chart: null,
      error: false
    }
  },

  watch: {
    data: {
      handler: 'redraw',
      deep: true
    },
    options: 'redraw'
  },

  methods: {
    draw () {
      const types = {
        bar: 'Bar',
        line: 'Line',
        pie: 'Pie'
      }
      const type = types[this.type]

      this.$chart = new chartist[type](this.$refs.chart, this.data, this.options)
    },

    reset () {
      this.error = false
    },

    redraw () {
      if (this.error) {
        return this.draw()
      }

      this.reset()
      this.$chart.update(this.data, this.options)
    }
  },

  mounted () {
    this.draw()
  },

  beforeDestroy () {
    this.reset()
  }
}
</script>

<style lang="scss">
// Series names and colors. This can be extended or customized as desired. Just add more series and colors.
$ct-series-names: (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o);
$ct-series-colors: (
  $primary,
  #a748ca,
  $pink,
  #b2c326,
  $green,
  #6188e2,
  #86797d,
  $blue,
  $blue,
  $purple,
  $red,
  $orange,
  $yellow,
  $teal,
  $cyan
);

@import "~chartist/dist/scss/chartist";

.ct-line {
  stroke-width: 2px;
}

.ct-point {
  stroke-width: 6px;
}
</style>
